import 'package:json_annotation/json_annotation.dart';
import 'package:equatable/equatable.dart';
import 'models.dart';

part 'checkin_body.g.dart';

@JsonSerializable()
class CheckinBody extends Equatable {
  @JsonKey(name: 'movie')
  final TraktMediaItem movie;
  @JsonKey(name: 'episode')
  final TraktMediaItem episode;
  @JsonKey(name: 'sharing')
  final Connections sharing;
  @JsonKey(name: 'venue_id')
  final String venueId;
  @JsonKey(name: 'venue_name')
  final String venueName;
  @JsonKey(name: 'app_version')
  final String appVersion;
  @JsonKey(name: 'app_date')
  final String appDate;

  CheckinBody(
      {this.movie,
      this.episode,
      this.sharing,
      this.venueId,
      this.venueName,
      this.appVersion,
      this.appDate})
      : assert(movie != null || episode != null);

  factory CheckinBody.fromJson(Map<String, dynamic> json) =>
      _$CheckinBodyFromJson(json);

  Map<String, dynamic> toJson() => _$CheckinBodyToJson(this);

  @override
  List<Object> get props => [
        this.movie,
        this.episode,
        this.sharing,
        this.venueId,
        this.venueName,
        this.appVersion,
        this.appDate
      ];
}
