import 'package:json_annotation/json_annotation.dart';
import 'package:equatable/equatable.dart';

part 'connections.g.dart';

@JsonSerializable()
class Connections extends Equatable {
  @JsonKey(name: 'facebook')
  final bool facebook;
  @JsonKey(name: 'twitter')
  final bool twitter;
  @JsonKey(name: 'google')
  final bool google;
  @JsonKey(name: 'tumblr')
  final bool tumblr;
  @JsonKey(name: 'medium')
  final bool medium;
  @JsonKey(name: 'slack')
  final bool slack;

  Connections(
      {this.facebook,
      this.twitter,
      this.google,
      this.tumblr,
      this.medium,
      this.slack});

  factory Connections.fromJson(Map<String, dynamic> json) =>
      _$ConnectionsFromJson(json);

  Map<String, dynamic> toJson() => _$ConnectionsToJson(this);

  @override
  List<Object> get props => [
        this.facebook,
        this.twitter,
        this.google,
        this.tumblr,
        this.medium,
        this.slack
      ];
}
