import 'package:json_annotation/json_annotation.dart';
import 'package:equatable/equatable.dart';
import 'package:meta/meta.dart';

part 'get_access_token_from_device_code_body.g.dart';

@JsonSerializable()
class GetAccessTokenFromDeviceCodeBody extends Equatable {
  @JsonKey(name: 'code')
  final String code;
  @JsonKey(name: 'client_id')
  final String clientId;
  @JsonKey(name: 'client_secret')
  final String clientSecret;

  GetAccessTokenFromDeviceCodeBody(
      {@required this.code, this.clientId, this.clientSecret});

  factory GetAccessTokenFromDeviceCodeBody.fromJson(
          Map<String, dynamic> json) =>
      _$GetAccessTokenFromDeviceCodeBodyFromJson(json);

  Map<String, dynamic> toJson() =>
      _$GetAccessTokenFromDeviceCodeBodyToJson(this);

  @override
  List<Object> get props => [this.code, this.clientId, this.clientSecret];
}
