import 'package:json_annotation/json_annotation.dart';
import 'package:equatable/equatable.dart';
import 'package:meta/meta.dart';

part 'reply_body.g.dart';

@JsonSerializable()
class ReplyBody extends Equatable {
  @JsonKey(name: 'comment')
  final String comment;
  @JsonKey(name: 'spoiler')
  final bool spoiler;

  ReplyBody({@required this.comment, this.spoiler});

  factory ReplyBody.fromJson(Map<String, dynamic> json) =>
      _$ReplyBodyFromJson(json);

  Map<String, dynamic> toJson() => _$ReplyBodyToJson(this);

  @override
  List<Object> get props => [this.comment, this.spoiler];
}
