import 'package:json_annotation/json_annotation.dart';
import 'package:equatable/equatable.dart';
import 'package:meta/meta.dart';
import "models.dart";

part 'scrobble_body.g.dart';

@JsonSerializable()
class ScrobbleBody extends Equatable {
  @JsonKey(name: 'movie')
  final TraktMediaItem movie;
  @JsonKey(name: 'episode')
  final TraktMediaItem episode;
  @JsonKey(name: 'show')
  final TraktMediaItem show;
  @JsonKey(name: 'progress')
  final double progress;
  @JsonKey(name: 'app_version')
  final String appVersion;
  @JsonKey(name: 'app_date')
  final String appDate;

  ScrobbleBody(
      {this.movie,
      this.episode,
      this.show,
      @required this.progress,
      this.appVersion,
      this.appDate})
      : assert(movie != null || episode != null || show != null);

  factory ScrobbleBody.fromJson(Map<String, dynamic> json) =>
      _$ScrobbleBodyFromJson(json);

  Map<String, dynamic> toJson() => _$ScrobbleBodyToJson(this);

  @override
  List<Object> get props => [
        this.movie,
        this.episode,
        this.show,
        this.progress,
        this.appVersion,
        this.appDate
      ];
}
