import 'package:json_annotation/json_annotation.dart';
import 'package:equatable/equatable.dart';

part 'social_ids.g.dart';

@JsonSerializable()
class SocialIds extends Equatable {
  @JsonKey(name: 'facebook')
  final String facebook;
  @JsonKey(name: 'twitter')
  final String twitter;
  @JsonKey(name: 'google')
  final String google;
  @JsonKey(name: 'tumblr')
  final String tumblr;
  @JsonKey(name: 'medium')
  final String medium;
  @JsonKey(name: 'slack')
  final String slack;
  @JsonKey(name: 'wikipedia')
  final String wikipedia;

  SocialIds(
      {this.facebook,
      this.twitter,
      this.google,
      this.tumblr,
      this.medium,
      this.slack,
      this.wikipedia});

  factory SocialIds.fromJson(Map<String, dynamic> json) =>
      _$SocialIdsFromJson(json);

  Map<String, dynamic> toJson() => _$SocialIdsToJson(this);

  @override
  List<Object> get props => [
        this.facebook,
        this.twitter,
        this.google,
        this.tumblr,
        this.medium,
        this.slack,
        this.wikipedia
      ];
}
