import 'package:json_annotation/json_annotation.dart';
import 'package:equatable/equatable.dart';
import 'models.dart';

part 'synch_history_body.g.dart';

@JsonSerializable()
class SynchHistoryBody extends Equatable {
  @JsonKey(name: 'movies')
  final List<TraktMediaItem> movies;
  @JsonKey(name: 'shows')
  final List<TraktMediaItem> shows;
  @JsonKey(name: 'seasons')
  final List<TraktMediaItem> seasons;
  @JsonKey(name: 'episodes')
  final List<TraktMediaItem> episodes;
  @JsonKey(name: 'ids')
  final List<int> ids;

  SynchHistoryBody({
    this.movies = const [],
    this.shows = const [],
    this.seasons = const [],
    this.episodes = const [],
    this.ids = const [],
  });

  factory SynchHistoryBody.fromJson(Map<String, dynamic> json) =>
      _$SynchHistoryBodyFromJson(json);

  Map<String, dynamic> toJson() => _$SynchHistoryBodyToJson(this);

  @override
  List<Object> get props =>
      [this.movies, this.shows, this.seasons, this.episodes, this.ids];
}
