import 'package:json_annotation/json_annotation.dart';
import 'package:equatable/equatable.dart';
import 'models.dart';

part 'trakt_media_item.g.dart';

@JsonSerializable()
class TraktMediaItem extends Equatable {
  @JsonKey(name: 'title')
  final String title;
  @JsonKey(name: 'year')
  final int year;
  @JsonKey(name: 'ids')
  final Ids ids;
  @JsonKey(name: 'tagline')
  final String tagline;
  @JsonKey(name: 'overview')
  final String overview;
  @JsonKey(name: 'released')
  final String released;
  @JsonKey(name: 'runtime')
  final int runtime;
  @JsonKey(name: 'country')
  final String country;
  @JsonKey(name: 'trailer')
  final String trailer;
  @JsonKey(name: 'homepage')
  final String homepage;
  @JsonKey(name: 'status')
  final String status;
  @JsonKey(name: 'rating')
  final double rating;
  @JsonKey(name: 'votes')
  final int votes;
  @JsonKey(name: 'comment_count')
  final int commentCount;
  @JsonKey(name: 'updated_at')
  final String updatedAt;
  @JsonKey(name: 'language')
  final String language;
  @JsonKey(name: 'available_translations')
  final List<String> availableTranslations;
  @JsonKey(name: 'genres')
  final List<String> genres;
  @JsonKey(name: 'certification')
  final String certification;
  @JsonKey(name: 'name')
  final String name;
  @JsonKey(name: 'social_ids')
  final SocialIds socialIds;
  @JsonKey(name: 'biography')
  final String biography;
  @JsonKey(name: 'birthday')
  final String birthday;
  @JsonKey(name: 'death')
  final String death;
  @JsonKey(name: 'birthplace')
  final String birthplace;
  @JsonKey(name: 'number')
  final int number;
  @JsonKey(name: 'episode_count')
  final int episodeCount;
  @JsonKey(name: 'aired_episodes')
  final int airedEpisodes;
  @JsonKey(name: 'first_aired')
  final String firstAired;
  @JsonKey(name: 'network')
  final String network;
  @JsonKey(name: 'episodes')
  final List<TraktMediaItem> episodes;
  @JsonKey(name: 'season')
  final int season;
  @JsonKey(name: 'number_abs')
  final int numberAbs;
  @JsonKey(name: 'description')
  final String description;
  @JsonKey(name: 'privacy')
  final String privacy;
  @JsonKey(name: 'display_numbers')
  final bool displayNumbers;
  @JsonKey(name: 'allow_comments')
  final bool allowComments;
  @JsonKey(name: 'sort_by')
  final String sortBy;
  @JsonKey(name: 'sort_how')
  final String sortHow;
  @JsonKey(name: 'created_at')
  final String createdAt;
  @JsonKey(name: 'item_count')
  final int itemCount;
  @JsonKey(name: 'likes')
  final int likes;
  @JsonKey(name: 'user')
  final User user;
  @JsonKey(name: 'account')
  final Account account;
  @JsonKey(name: 'connections')
  final Connections connections;
  @JsonKey(name: 'sharing_text')
  final SharingText sharingText;
  @JsonKey(name: 'collected_at')
  final String collectedAt;
  @JsonKey(name: 'watched_at')
  final String watchedAt;
  @JsonKey(name: 'rated_at')
  final String ratedAt;
  @JsonKey(name: 'notes')
  final String notes;
  @JsonKey(name: 'progress')
  final double progress;
  @JsonKey(name: 'app_version')
  final String appVersion;
  @JsonKey(name: 'app_date')
  final String appDate;
  @JsonKey(name: 'comment')
  final String comment;
  @JsonKey(name: 'spoiler')
  final bool spoiler;
  @JsonKey(name: 'type')
  final TraktMediaItemType type;

  TraktMediaItem(
      {this.title,
      this.year,
      this.ids,
      this.tagline,
      this.overview,
      this.released,
      this.runtime,
      this.country,
      this.trailer,
      this.homepage,
      this.status,
      this.rating,
      this.votes,
      this.commentCount,
      this.updatedAt,
      this.language,
      this.availableTranslations,
      this.genres,
      this.certification,
      this.name,
      this.socialIds,
      this.biography,
      this.birthday,
      this.death,
      this.birthplace,
      this.number,
      this.episodeCount,
      this.airedEpisodes,
      this.firstAired,
      this.network,
      this.episodes,
      this.season,
      this.numberAbs,
      this.description,
      this.privacy,
      this.displayNumbers,
      this.allowComments,
      this.sortBy,
      this.sortHow,
      this.createdAt,
      this.itemCount,
      this.likes,
      this.user,
      this.account,
      this.connections,
      this.sharingText,
      this.collectedAt,
      this.watchedAt,
      this.ratedAt,
      this.notes,
      this.progress,
      this.appVersion,
      this.appDate,
      this.comment,
      this.spoiler,
      this.type});

  factory TraktMediaItem.fromJson(Map<String, dynamic> json) =>
      _$TraktMediaItemFromJson(json);

  Map<String, dynamic> toJson() => _$TraktMediaItemToJson(this);

  @override
  List<Object> get props => [
        this.title,
        this.year,
        this.ids,
        this.tagline,
        this.overview,
        this.released,
        this.runtime,
        this.country,
        this.trailer,
        this.homepage,
        this.status,
        this.rating,
        this.votes,
        this.commentCount,
        this.updatedAt,
        this.language,
        this.availableTranslations,
        this.genres,
        this.certification,
        this.name,
        this.socialIds,
        this.biography,
        this.birthday,
        this.death,
        this.birthplace,
        this.number,
        this.episodeCount,
        this.airedEpisodes,
        this.firstAired,
        this.network,
        this.episodes,
        this.season,
        this.numberAbs,
        this.description,
        this.privacy,
        this.displayNumbers,
        this.allowComments,
        this.sortBy,
        this.sortHow,
        this.createdAt,
        this.itemCount,
        this.likes,
        this.user,
        this.account,
        this.connections,
        this.sharingText,
        this.collectedAt,
        this.watchedAt,
        this.ratedAt,
        this.notes,
        this.progress,
        this.appVersion,
        this.appDate,
        this.comment,
        this.spoiler,
        this.type
      ];
}
