import 'package:dio/dio.dart';
import 'package:retrofit/retrofit.dart';
import '../../../trakt.dart';

part 'checkin.g.dart';

@RestApi()
abstract class Checkin {
  factory Checkin(Dio dio, {String baseUrl}) = _Checkin;

  @POST('/checkin')
  Future<HttpResponse<dynamic>> checkIn(
    @Body() CheckinBody checkinBody, {
    @Query('client_id') String clientId,
    @Header('content-type') String contentType,
    @Header('trakt-api-version') String traktApiVersion,
    @Header('trakt-api-key') String traktApiKey,
    @Header('Authorization') String accessToken,
    @Queries() Map<String, dynamic> additionalQueries,
  });

  @DELETE('/checkin')
  Future<HttpResponse<dynamic>> deleteActiveCheckins({
    @Query('client_id') String clientId,
    @Header('content-type') String contentType,
    @Header('trakt-api-version') String traktApiVersion,
    @Header('trakt-api-key') String traktApiKey,
    @Header('Authorization') String accessToken,
    @Queries() Map<String, dynamic> additionalQueries,
  });
}
