import 'package:dio/dio.dart';
import 'package:retrofit/retrofit.dart';
import '../../../trakt.dart';

part 'countries.g.dart';

@RestApi()
abstract class Countries {
  factory Countries(Dio dio, {String baseUrl}) = _Countries;

  @GET('/countries/{type}')
  Future<HttpResponse<dynamic>> getCountries(
    @Path('type') AlternateMediaType alternateMediaType, {
    @Query('client_id') String clientId,
    @Header('content-type') String contentType,
    @Header('trakt-api-version') String traktApiVersion,
    @Header('trakt-api-key') String traktApiKey,
    @Header('Authorization') String accessToken,
    @Queries() Map<String, dynamic> additionalQueries,
  });
}
