// GENERATED CODE - DO NOT MODIFY BY HAND

part of 'episodes.dart';

// **************************************************************************
// RetrofitGenerator
// **************************************************************************

class _Episodes implements Episodes {
  _Episodes(this._dio, {this.baseUrl}) {
    ArgumentError.checkNotNull(_dio, '_dio');
  }

  final Dio _dio;

  String baseUrl;

  @override
  Future<HttpResponse<dynamic>> getDetails(showId, seasonNumber, episodeNumber,
      {contentType,
      traktApiVersion,
      traktApiKey,
      accessToken,
      clientId,
      extendedInfo,
      additionalQueries}) async {
    ArgumentError.checkNotNull(showId, 'showId');
    ArgumentError.checkNotNull(seasonNumber, 'seasonNumber');
    ArgumentError.checkNotNull(episodeNumber, 'episodeNumber');
    const _extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{
      r'client_id': clientId,
      r'extended': extendedInfo
    };
    queryParameters.addAll(additionalQueries ?? <String, dynamic>{});
    queryParameters.removeWhere((k, v) => v == null);
    final _data = <String, dynamic>{};
    final _result = await _dio.request(
        '/shows/$showId/seasons/$seasonNumber/episodes/$episodeNumber',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{
              r'content-type': contentType,
              r'trakt-api-version': traktApiVersion,
              r'trakt-api-key': traktApiKey,
              r'Authorization': accessToken
            },
            extra: _extra,
            contentType: contentType,
            baseUrl: baseUrl),
        data: _data);
    final value = _result.data;
    final httpResponse = HttpResponse(value, _result);
    return httpResponse;
  }

  @override
  Future<HttpResponse<dynamic>> getTranslations(
      showId, seasonNumber, episodeNumber,
      {language,
      contentType,
      traktApiVersion,
      traktApiKey,
      accessToken,
      clientId,
      additionalQueries}) async {
    ArgumentError.checkNotNull(showId, 'showId');
    ArgumentError.checkNotNull(seasonNumber, 'seasonNumber');
    ArgumentError.checkNotNull(episodeNumber, 'episodeNumber');
    const _extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{r'client_id': clientId};
    queryParameters.addAll(additionalQueries ?? <String, dynamic>{});
    queryParameters.removeWhere((k, v) => v == null);
    final _data = <String, dynamic>{};
    final _result = await _dio.request(
        '/shows/$showId/seasons/$seasonNumber/episodes/$episodeNumber/translations/$language',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{
              r'content-type': contentType,
              r'trakt-api-version': traktApiVersion,
              r'trakt-api-key': traktApiKey,
              r'Authorization': accessToken
            },
            extra: _extra,
            contentType: contentType,
            baseUrl: baseUrl),
        data: _data);
    final value = _result.data;
    final httpResponse = HttpResponse(value, _result);
    return httpResponse;
  }

  @override
  Future<HttpResponse<dynamic>> getComments(showId, seasonNumber, episodeNumber,
      {showCommentsSortBy,
      contentType,
      traktApiVersion,
      traktApiKey,
      accessToken,
      clientId,
      page,
      limit,
      additionalQueries}) async {
    ArgumentError.checkNotNull(showId, 'showId');
    ArgumentError.checkNotNull(seasonNumber, 'seasonNumber');
    ArgumentError.checkNotNull(episodeNumber, 'episodeNumber');
    const _extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{
      r'client_id': clientId,
      r'page': page,
      r'limit': limit
    };
    queryParameters.addAll(additionalQueries ?? <String, dynamic>{});
    queryParameters.removeWhere((k, v) => v == null);
    final _data = <String, dynamic>{};
    final _result = await _dio.request(
        '/shows/$showId/seasons/$seasonNumber/episodes/$episodeNumber/comments/$showCommentsSortBy',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{
              r'content-type': contentType,
              r'trakt-api-version': traktApiVersion,
              r'trakt-api-key': traktApiKey,
              r'Authorization': accessToken
            },
            extra: _extra,
            contentType: contentType,
            baseUrl: baseUrl),
        data: _data);
    final value = _result.data;
    final httpResponse = HttpResponse(value, _result);
    return httpResponse;
  }

  @override
  Future<HttpResponse<dynamic>> getLists(showId, seasonNumber, episodeNumber,
      {mediaListTypes,
      mediaListSortBy,
      contentType,
      traktApiVersion,
      traktApiKey,
      accessToken,
      clientId,
      page,
      limit,
      additionalQueries}) async {
    ArgumentError.checkNotNull(showId, 'showId');
    ArgumentError.checkNotNull(seasonNumber, 'seasonNumber');
    ArgumentError.checkNotNull(episodeNumber, 'episodeNumber');
    const _extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{
      r'client_id': clientId,
      r'page': page,
      r'limit': limit
    };
    queryParameters.addAll(additionalQueries ?? <String, dynamic>{});
    queryParameters.removeWhere((k, v) => v == null);
    final _data = <String, dynamic>{};
    final _result = await _dio.request(
        '/shows/$showId/seasons/$seasonNumber/episodes/$episodeNumber/lists/$mediaListTypes/$mediaListSortBy',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{
              r'content-type': contentType,
              r'trakt-api-version': traktApiVersion,
              r'trakt-api-key': traktApiKey,
              r'Authorization': accessToken
            },
            extra: _extra,
            contentType: contentType,
            baseUrl: baseUrl),
        data: _data);
    final value = _result.data;
    final httpResponse = HttpResponse(value, _result);
    return httpResponse;
  }

  @override
  Future<HttpResponse<dynamic>> getPeople(showId, seasonNumber, episodeNumber,
      {contentType,
      traktApiVersion,
      traktApiKey,
      accessToken,
      clientId,
      extendedInfo,
      additionalQueries}) async {
    ArgumentError.checkNotNull(showId, 'showId');
    ArgumentError.checkNotNull(seasonNumber, 'seasonNumber');
    ArgumentError.checkNotNull(episodeNumber, 'episodeNumber');
    const _extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{
      r'client_id': clientId,
      r'extended': extendedInfo
    };
    queryParameters.addAll(additionalQueries ?? <String, dynamic>{});
    queryParameters.removeWhere((k, v) => v == null);
    final _data = <String, dynamic>{};
    final _result = await _dio.request(
        '/shows/$showId/seasons/$seasonNumber/episodes/$episodeNumber/people',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{
              r'content-type': contentType,
              r'trakt-api-version': traktApiVersion,
              r'trakt-api-key': traktApiKey,
              r'Authorization': accessToken
            },
            extra: _extra,
            contentType: contentType,
            baseUrl: baseUrl),
        data: _data);
    final value = _result.data;
    final httpResponse = HttpResponse(value, _result);
    return httpResponse;
  }

  @override
  Future<HttpResponse<dynamic>> getRatingDistribution(
      showId, seasonNumber, episodeNumber,
      {contentType,
      traktApiVersion,
      traktApiKey,
      accessToken,
      clientId,
      additionalQueries}) async {
    ArgumentError.checkNotNull(showId, 'showId');
    ArgumentError.checkNotNull(seasonNumber, 'seasonNumber');
    ArgumentError.checkNotNull(episodeNumber, 'episodeNumber');
    const _extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{r'client_id': clientId};
    queryParameters.addAll(additionalQueries ?? <String, dynamic>{});
    queryParameters.removeWhere((k, v) => v == null);
    final _data = <String, dynamic>{};
    final _result = await _dio.request(
        '/shows/$showId/seasons/$seasonNumber/episodes/$episodeNumber/ratings',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{
              r'content-type': contentType,
              r'trakt-api-version': traktApiVersion,
              r'trakt-api-key': traktApiKey,
              r'Authorization': accessToken
            },
            extra: _extra,
            contentType: contentType,
            baseUrl: baseUrl),
        data: _data);
    final value = _result.data;
    final httpResponse = HttpResponse(value, _result);
    return httpResponse;
  }

  @override
  Future<HttpResponse<dynamic>> getStats(showId, seasonNumber, episodeNumber,
      {contentType,
      traktApiVersion,
      traktApiKey,
      accessToken,
      clientId,
      additionalQueries}) async {
    ArgumentError.checkNotNull(showId, 'showId');
    ArgumentError.checkNotNull(seasonNumber, 'seasonNumber');
    ArgumentError.checkNotNull(episodeNumber, 'episodeNumber');
    const _extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{r'client_id': clientId};
    queryParameters.addAll(additionalQueries ?? <String, dynamic>{});
    queryParameters.removeWhere((k, v) => v == null);
    final _data = <String, dynamic>{};
    final _result = await _dio.request(
        '/shows/$showId/seasons/$seasonNumber/episodes/$episodeNumber/stats',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{
              r'content-type': contentType,
              r'trakt-api-version': traktApiVersion,
              r'trakt-api-key': traktApiKey,
              r'Authorization': accessToken
            },
            extra: _extra,
            contentType: contentType,
            baseUrl: baseUrl),
        data: _data);
    final value = _result.data;
    final httpResponse = HttpResponse(value, _result);
    return httpResponse;
  }

  @override
  Future<HttpResponse<dynamic>> getUsersWatching(
      showId, seasonNumber, episodeNumber,
      {contentType,
      traktApiVersion,
      traktApiKey,
      accessToken,
      clientId,
      extendedInfo,
      additionalQueries}) async {
    ArgumentError.checkNotNull(showId, 'showId');
    ArgumentError.checkNotNull(seasonNumber, 'seasonNumber');
    ArgumentError.checkNotNull(episodeNumber, 'episodeNumber');
    const _extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{
      r'client_id': clientId,
      r'extended': extendedInfo
    };
    queryParameters.addAll(additionalQueries ?? <String, dynamic>{});
    queryParameters.removeWhere((k, v) => v == null);
    final _data = <String, dynamic>{};
    final _result = await _dio.request(
        '/shows/$showId/seasons/$seasonNumber/episodes/$episodeNumber/watching',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{
              r'content-type': contentType,
              r'trakt-api-version': traktApiVersion,
              r'trakt-api-key': traktApiKey,
              r'Authorization': accessToken
            },
            extra: _extra,
            contentType: contentType,
            baseUrl: baseUrl),
        data: _data);
    final value = _result.data;
    final httpResponse = HttpResponse(value, _result);
    return httpResponse;
  }
}
