#!/bin/bash

for dir in $(find . -maxdepth 1 -type d); do
baseFile="$(basename $dir)"
file="$dir"/"$baseFile".dart
pascalName="$(echo $baseFile | sed -r 's/(^|_)([a-z])/\U\2/g')"
# echo "$file"
# > $file <<-
content="
import 'package:dio/dio.dart';
import 'package:retrofit/retrofit.dart';
import '../../../trakt.dart';

part '$baseFile.g.dart';

@RestApi()
abstract class $pascalName {
  factory $pascalName(Dio dio, {String baseUrl}) = _$pascalName;

  @GET('')
  Future<HttpResponse<dynamic>> temp(
      {@Query('client_id') String clientId,
      @Header('content-type') String contentType,
      @Header('trakt-api-version') String traktApiVersion,
      @Header('trakt-api-key') String traktApiKey,
      @Header('Authorization') String accessToken});
}
"
touch $file
if ! [ -s $file ]; then
  echo "$content" > $file
fi

done