import 'package:dio/dio.dart';
import 'package:retrofit/retrofit.dart';
import '../../../trakt.dart';

part 'languages.g.dart';

@RestApi()
abstract class Languages {
  factory Languages(Dio dio, {String baseUrl}) = _Languages;

  @GET('/languages/{type}')
  Future<HttpResponse<dynamic>> getLanguages(
    @Path('type') AlternateMediaType alternateMediaType, {
    @Query('client_id') String clientId,
    @Header('content-type') String contentType,
    @Header('trakt-api-version') String traktApiVersion,
    @Header('trakt-api-key') String traktApiKey,
    @Header('Authorization') String accessToken,
    @Queries() Map<String, dynamic> additionalQueries,
  });
}
