import 'package:dio/dio.dart';
import 'package:retrofit/retrofit.dart';
import '../../../trakt.dart';

part 'search.g.dart';

@RestApi()
abstract class Search {
  factory Search(Dio dio, {String baseUrl}) = _Search;

  @GET('/search/{type}')
  Future<HttpResponse<dynamic>> query({
    @Header('content-type') String contentType,
    @Header('trakt-api-version') String traktApiVersion,
    @Header('trakt-api-key') String traktApiKey,
    @Header('Authorization') String accessToken,
    @Query('client_id') String clientId,
    @Query('page') int page,
    @Query('limit') int limit,
    @Query('extended') String extendedInfo,
    @Query('query') String query,
    @Query('years') String years,
    @Query('genres') String genres,
    @Query('languages') String languages,
    @Query('countries') String countries,
    @Query('runtimes') String runtimes,
    @Query('certifications') String certifications,
    @Query('networks') String networks,
    @Query('status') String status,
    @Query('ratings') String ratings,
    @Query('fields') String fields,
    @Queries() Map<String, dynamic> additionalQueries,
  });

  @GET('/search/{id_type}/{id}')
  Future<HttpResponse<dynamic>> byID(
    @Path('id_type') SearchMediaIdType searchMediaIdType,
    @Path('id') String mediaId, {
    @Header('content-type') String contentType,
    @Header('trakt-api-version') String traktApiVersion,
    @Header('trakt-api-key') String traktApiKey,
    @Header('Authorization') String accessToken,
    @Query('client_id') String clientId,
    @Query('type') SearchMediaItemType searchMediaItemType,
    @Query('page') int page,
    @Query('limit') int limit,
    @Query('extended') String extendedInfo,
    @Queries() Map<String, dynamic> additionalQueries,
  });
}
