// GENERATED CODE - DO NOT MODIFY BY HAND

part of 'seasons.dart';

// **************************************************************************
// RetrofitGenerator
// **************************************************************************

class _Seasons implements Seasons {
  _Seasons(this._dio, {this.baseUrl}) {
    ArgumentError.checkNotNull(_dio, '_dio');
  }

  final Dio _dio;

  String baseUrl;

  @override
  Future<HttpResponse<dynamic>> getAllSeasons(showId,
      {contentType,
      traktApiVersion,
      traktApiKey,
      accessToken,
      clientId,
      extendedInfo,
      additionalQueries}) async {
    ArgumentError.checkNotNull(showId, 'showId');
    const _extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{
      r'client_id': clientId,
      r'extended': extendedInfo
    };
    queryParameters.addAll(additionalQueries ?? <String, dynamic>{});
    queryParameters.removeWhere((k, v) => v == null);
    final _data = <String, dynamic>{};
    final _result = await _dio.request('/shows/$showId/seasons',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{
              r'content-type': contentType,
              r'trakt-api-version': traktApiVersion,
              r'trakt-api-key': traktApiKey,
              r'Authorization': accessToken
            },
            extra: _extra,
            contentType: contentType,
            baseUrl: baseUrl),
        data: _data);
    final value = _result.data;
    final httpResponse = HttpResponse(value, _result);
    return httpResponse;
  }

  @override
  Future<HttpResponse<dynamic>> getSingleSeason(showId, seasonNumber,
      {contentType,
      traktApiVersion,
      traktApiKey,
      accessToken,
      clientId,
      translations,
      extendedInfo,
      additionalQueries}) async {
    ArgumentError.checkNotNull(showId, 'showId');
    ArgumentError.checkNotNull(seasonNumber, 'seasonNumber');
    const _extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{
      r'client_id': clientId,
      r'translations': translations,
      r'extended': extendedInfo
    };
    queryParameters.addAll(additionalQueries ?? <String, dynamic>{});
    queryParameters.removeWhere((k, v) => v == null);
    final _data = <String, dynamic>{};
    final _result = await _dio.request('/shows/$showId/seasons/$seasonNumber',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{
              r'content-type': contentType,
              r'trakt-api-version': traktApiVersion,
              r'trakt-api-key': traktApiKey,
              r'Authorization': accessToken
            },
            extra: _extra,
            contentType: contentType,
            baseUrl: baseUrl),
        data: _data);
    final value = _result.data;
    final httpResponse = HttpResponse(value, _result);
    return httpResponse;
  }

  @override
  Future<HttpResponse<dynamic>> getComments(showId, seasonNumber,
      {showCommentsSortBy,
      contentType,
      traktApiVersion,
      traktApiKey,
      accessToken,
      clientId,
      page,
      limit,
      additionalQueries}) async {
    ArgumentError.checkNotNull(showId, 'showId');
    ArgumentError.checkNotNull(seasonNumber, 'seasonNumber');
    const _extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{
      r'client_id': clientId,
      r'page': page,
      r'limit': limit
    };
    queryParameters.addAll(additionalQueries ?? <String, dynamic>{});
    queryParameters.removeWhere((k, v) => v == null);
    final _data = <String, dynamic>{};
    final _result = await _dio.request(
        '/shows/$showId/seasons/$seasonNumber/comments/$showCommentsSortBy',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{
              r'content-type': contentType,
              r'trakt-api-version': traktApiVersion,
              r'trakt-api-key': traktApiKey,
              r'Authorization': accessToken
            },
            extra: _extra,
            contentType: contentType,
            baseUrl: baseUrl),
        data: _data);
    final value = _result.data;
    final httpResponse = HttpResponse(value, _result);
    return httpResponse;
  }

  @override
  Future<HttpResponse<dynamic>> getLists(showId, seasonNumber,
      {mediaListTypes,
      mediaListSortBy,
      contentType,
      traktApiVersion,
      traktApiKey,
      accessToken,
      clientId,
      page,
      limit,
      additionalQueries}) async {
    ArgumentError.checkNotNull(showId, 'showId');
    ArgumentError.checkNotNull(seasonNumber, 'seasonNumber');
    const _extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{
      r'client_id': clientId,
      r'page': page,
      r'limit': limit
    };
    queryParameters.addAll(additionalQueries ?? <String, dynamic>{});
    queryParameters.removeWhere((k, v) => v == null);
    final _data = <String, dynamic>{};
    final _result = await _dio.request(
        '/shows/$showId/seasons/$seasonNumber/lists/$mediaListTypes/$mediaListSortBy',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{
              r'content-type': contentType,
              r'trakt-api-version': traktApiVersion,
              r'trakt-api-key': traktApiKey,
              r'Authorization': accessToken
            },
            extra: _extra,
            contentType: contentType,
            baseUrl: baseUrl),
        data: _data);
    final value = _result.data;
    final httpResponse = HttpResponse(value, _result);
    return httpResponse;
  }

  @override
  Future<HttpResponse<dynamic>> getPeople(showId, seasonNumber,
      {contentType,
      traktApiVersion,
      traktApiKey,
      accessToken,
      clientId,
      extendedInfo,
      additionalQueries}) async {
    ArgumentError.checkNotNull(showId, 'showId');
    ArgumentError.checkNotNull(seasonNumber, 'seasonNumber');
    const _extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{
      r'client_id': clientId,
      r'extended': extendedInfo
    };
    queryParameters.addAll(additionalQueries ?? <String, dynamic>{});
    queryParameters.removeWhere((k, v) => v == null);
    final _data = <String, dynamic>{};
    final _result =
        await _dio.request('/shows/$showId/seasons/$seasonNumber/people',
            queryParameters: queryParameters,
            options: RequestOptions(
                method: 'GET',
                headers: <String, dynamic>{
                  r'content-type': contentType,
                  r'trakt-api-version': traktApiVersion,
                  r'trakt-api-key': traktApiKey,
                  r'Authorization': accessToken
                },
                extra: _extra,
                contentType: contentType,
                baseUrl: baseUrl),
            data: _data);
    final value = _result.data;
    final httpResponse = HttpResponse(value, _result);
    return httpResponse;
  }

  @override
  Future<HttpResponse<dynamic>> getRatingDistribution(showId, seasonNumber,
      {contentType,
      traktApiVersion,
      traktApiKey,
      accessToken,
      clientId,
      additionalQueries}) async {
    ArgumentError.checkNotNull(showId, 'showId');
    ArgumentError.checkNotNull(seasonNumber, 'seasonNumber');
    const _extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{r'client_id': clientId};
    queryParameters.addAll(additionalQueries ?? <String, dynamic>{});
    queryParameters.removeWhere((k, v) => v == null);
    final _data = <String, dynamic>{};
    final _result =
        await _dio.request('/shows/$showId/seasons/$seasonNumber/ratings',
            queryParameters: queryParameters,
            options: RequestOptions(
                method: 'GET',
                headers: <String, dynamic>{
                  r'content-type': contentType,
                  r'trakt-api-version': traktApiVersion,
                  r'trakt-api-key': traktApiKey,
                  r'Authorization': accessToken
                },
                extra: _extra,
                contentType: contentType,
                baseUrl: baseUrl),
            data: _data);
    final value = _result.data;
    final httpResponse = HttpResponse(value, _result);
    return httpResponse;
  }

  @override
  Future<HttpResponse<dynamic>> getStats(showId, seasonNumber,
      {contentType,
      traktApiVersion,
      traktApiKey,
      accessToken,
      clientId,
      additionalQueries}) async {
    ArgumentError.checkNotNull(showId, 'showId');
    ArgumentError.checkNotNull(seasonNumber, 'seasonNumber');
    const _extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{r'client_id': clientId};
    queryParameters.addAll(additionalQueries ?? <String, dynamic>{});
    queryParameters.removeWhere((k, v) => v == null);
    final _data = <String, dynamic>{};
    final _result =
        await _dio.request('/shows/$showId/seasons/$seasonNumber/ratings',
            queryParameters: queryParameters,
            options: RequestOptions(
                method: 'GET',
                headers: <String, dynamic>{
                  r'content-type': contentType,
                  r'trakt-api-version': traktApiVersion,
                  r'trakt-api-key': traktApiKey,
                  r'Authorization': accessToken
                },
                extra: _extra,
                contentType: contentType,
                baseUrl: baseUrl),
            data: _data);
    final value = _result.data;
    final httpResponse = HttpResponse(value, _result);
    return httpResponse;
  }

  @override
  Future<HttpResponse<dynamic>> getUsersWatching(showId, seasonNumber,
      {contentType,
      traktApiVersion,
      traktApiKey,
      accessToken,
      clientId,
      extendedInfo,
      additionalQueries}) async {
    ArgumentError.checkNotNull(showId, 'showId');
    ArgumentError.checkNotNull(seasonNumber, 'seasonNumber');
    const _extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{
      r'client_id': clientId,
      r'extended': extendedInfo
    };
    queryParameters.addAll(additionalQueries ?? <String, dynamic>{});
    queryParameters.removeWhere((k, v) => v == null);
    final _data = <String, dynamic>{};
    final _result =
        await _dio.request('/shows/$showId/seasons/$seasonNumber/watching',
            queryParameters: queryParameters,
            options: RequestOptions(
                method: 'GET',
                headers: <String, dynamic>{
                  r'content-type': contentType,
                  r'trakt-api-version': traktApiVersion,
                  r'trakt-api-key': traktApiKey,
                  r'Authorization': accessToken
                },
                extra: _extra,
                contentType: contentType,
                baseUrl: baseUrl),
            data: _data);
    final value = _result.data;
    final httpResponse = HttpResponse(value, _result);
    return httpResponse;
  }
}
