#!/bin/bash
redaf=`tput setaf 1`
greenaf=`tput setaf 2`
yellowaf=`tput setaf 3`
blueaf=`tput setaf 4`
magentaaf=`tput setaf 5`
cyanaf=`tput setaf 6`
redab=`tput setab 1`
greenab=`tput setab 2`
yellowab=`tput setab 3`
blueab=`tput setab 4`
magentaab=`tput setab 5`
cyanab=`tput setab 6`
reset=`tput sgr0`
bold=`tput bold`

# Have to do this because the enums are not getting converted in Headers

searchStrings=(
    "alternateMediaType"
    "traktMediaItemType"
    "commentType"
    "listSortBy"
    "listSortHow"
    "listCommentsSortBy"
    )

for searchString in "${searchStrings[@]}"
do
    # echo "${magentaaf}${bold} [$searchString] ${reset}replacing ${yellowab}${bold}started${reset}"
    if [[ $searchString != "" ]]; then

        replacePatterns=(
            "s|\$$searchString|\${$searchString?.toJson()}|g"
            "s|: $searchString[,\n]|: $searchString?.toJson(),|g"
            )

        for replacePattern in "${replacePatterns[@]}"
        do
            if [[ $replacePattern != "" ]]; then
                # echo "${blueaf}${bold} [START] ${reset}replace pattern : \"$replacePattern\" ${yellowab}${bold}started${reset}"
                find . -type f -name "*.g.dart" -exec sed -i -z "$replacePattern" {} \;
                # echo "${greenaf}${bold} [DONE] ${reset}replace pattern : \"$replacePattern\" ${greenab}${bold}complete${reset}"

                # These will also work in case above things doesn't work
                # find . -type f -name "*.g.dart" -print0 | xargs -0 sed -i  "$replacePattern"
            fi
        done
    # echo "${magentaaf}${bold} [$searchString] ${reset}replacing ${greenab}${bold}complete${reset}"
    fi
done

dart format --fix .